#include "fftw3.h"
//#include <math.h>
#include <complex>
#include "stdafx.h"

class GausBlur;



class GaussianBlur : public GenericVideoFilter {
public:
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
	GaussianBlur(PClip clip,float sdy,float sdc,int border,bool integrate,float unsharpstrength,int y,int u,int v,IScriptEnvironment* env);
	~GaussianBlur();
protected:
	GausBlur *gbY;
	GausBlur *gbC;
	int Y;
	int U;
	int V;
};


class GausBlur {
public:
	GausBlur(unsigned int width,unsigned int height,float sd,int border,bool integrate,float unsharpstrength,IScriptEnvironment* env);
	~GausBlur();
	void Blur(int plane,PVideoFrame &src,PVideoFrame &dst, IScriptEnvironment* env);
protected:
	unsigned int height;
	unsigned int width;
	float sd;
	int border;
	unsigned int radius;
	void CalcGaus(bool integrate,bool unsharp,float strength);
	float GausBlur::RombergIntegral(float a,float b,float sd); 
	float *in;
	float *realout;
	float norm;
	//fftwf_complex *out[2];
	std::complex<float> *out;
	unsigned int outwidth;
	
	unsigned int srcwidth;
	
	unsigned int srcheight;
	std::complex<float>* gaus;
	fftwf_plan plan, plani;	
};