// VariableBlur.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "BinomialBlur.h"
#include "GaussianBlur.h"

BOOL  APIENTRY  __stdcall DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
/*
	if(ul_reason_for_call==DLL_PROCESS_ATTACH){
    int a=2;	
	}
	else if(ul_reason_for_call==DLL_THREAD_ATTACH){
		MessageBox(NULL,"THREAD ATTACH","ATTACH",MB_OK);
	}
	*/	
    return TRUE;

}





AVSValue __cdecl Create_binomialblur(AVSValue args, void* user_data, IScriptEnvironment* env){
	unsigned int radY=args[1].AsFloat(1.5)*2+0.1;
	unsigned int radC=args[2].AsFloat(1.5)*2+0.1;
	return new BinomialBlur(args[0].AsClip(),
		radY,
		radC,
		args[3].AsInt(3),
		args[4].AsInt(2),
		args[5].AsInt(2),
		true,
		args[6].AsBool(true),
		args[6].Defined(),
		true,
		env);
}

AVSValue __cdecl Create_averageblur(AVSValue args, void* user_data, IScriptEnvironment* env){
	return new BinomialBlur(args[0].AsClip(),
		args[1].AsInt(3),
		args[2].AsInt(3),
		args[3].AsInt(3),
		args[4].AsInt(2),
		args[5].AsInt(2),
		false,
		true,
		true,
		true,
		env);
}


AVSValue __cdecl Create_gaussianblur(AVSValue args, void* user_data, IScriptEnvironment* env){
	float sdY=sqrt(args[1].AsFloat(1));
	float sdC=sqrt(args[2].AsFloat(1));
	return new GaussianBlur(args[0].AsClip(),
		sdY,
		sdC,
        args[3].AsInt(1),
		args[4].AsBool(false),
		0,
		args[5].AsInt(3),
		args[6].AsInt(2),
		args[7].AsInt(2),
		env);
}

AVSValue __cdecl Create_unsharp(AVSValue args, void* user_data, IScriptEnvironment* env){
	float sdY=sqrt(args[1].AsFloat(1));
	float sdC=sqrt(args[2].AsFloat(1));
	return new GaussianBlur(args[0].AsClip(),
		sdY,
		sdC,
		args[4].AsInt(1),
		args[5].AsBool(false),
		args[3].AsFloat(0.7),
		args[6].AsInt(3),
		args[7].AsInt(2),
		args[8].AsInt(2),
		env);
}

extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env) {
env->AddFunction("BinomialBlur","c[varY]f[varC]f[Y]i[U]i[V]i[usemmx]b", Create_binomialblur, 0); 
env->AddFunction("AverageBlur","c[radY]i[radC]i[Y]i[U]i[V]i", Create_averageblur, 0); 
env->AddFunction("GaussianBlur","c[varY]f[varC]f[border]i[integrate]b[Y]i[U]i[V]i", Create_gaussianblur, 0); 
env->AddFunction("Unsharp","c[varY]f[varC]f[strength]f[border]i[integrate]b[Y]i[U]i[V]i", Create_unsharp, 0); 
return "VariableBlur version 0.4"; 
} 




